/*
** Copyright (C) 2002-2003 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __SNUFF_DB_H
#define __SNUFF_DB_H

#define USER_HASH_ORDER		6

struct user_record {
	uid_t uid;
	u_int32_t num_aliases;
	dlist_t *alias_list;
};

struct alias_record {
	char *alias;
	time_t expire;
};

struct saved_record {
	uid_t uid;
	char username[MAX_USERLEN];
	time_t expire;
};

int init_state(void);
int new_alias(uid_t uid, struct alias_block *alias, size_t len);
int delete_alias(uid_t uid, const char *alias);
int delete_all_aliases(uid_t uid);
int list_aliases(int sock, uid_t uid);
void expire_aliases(void);

int save_state(const char *state_file);
int read_state(const char *state_file);

#endif
